
# Programs must be written for people to read, and only incidentally for machines to execute.

module BHL

  module Polyhedra

    def icosahedron_civ1()

      # Creates an Icosahedron.

      puts 'Icosa V1'

      # To do: get model units and apply accordingly

      radius = (1.0).m

      icosa_v1 = Icosahedron.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron', true)

      cmpnt_def = icosa_v1.create_face_component(model)

      group = icosa_v1.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_civ1()

    def icosahedron_civ2()

      # Creates a Class I V2 Icosahedron.

      puts 'Icosa Class I V2'

      radius = (1.0).m

      icosa_civ2 = IcosahedronCIV2.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V2', true)

      cmpnt_def = icosa_civ2.create_civ2_face_component(model)

      group = icosa_civ2.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_civ2()

    def icosahedron_cim1v3()

      # Creates a Class I Method 1 V3 Icosahedron.

      puts 'Icosa Class I Method 1 V3'

      radius = (1.0).m

      icosa_cim1v3 = IcosahedronCIM1V3.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V3', true)

      cmpnt_def = icosa_cim1v3.create_cim1v3_face_component(model)

      group = icosa_cim1v3.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cim1v3()

    def icosahedron_cim1v4()

      # Creates a Class I Method 1 V4 Icosahedron.

      puts 'Icosa Class I Method 1 V4'

      radius = (1.0).m

      icosa_cim1v4 = IcosahedronCIM1V4.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V4', true)

      cmpnt_def = icosa_cim1v4.create_cim1v4_face_component(model)

      group = icosa_cim1v4.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cim1v4()

    def icosahedron_cim1v5()

      # Creates a Class I Method 1 V5 Icosahedron.

      puts 'Icosa Class I Method 1 V5'

      radius = (1.0).m

      icosa_cim1v5 = IcosahedronCIM1V5.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V5', true)

      cmpnt_def = icosa_cim1v5.create_cim1v5_face_component(model)

      group = icosa_cim1v5.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cim1v5()

    def icosahedron_cim1v6()

      # Creates a Class I Method 1 V6 Icosahedron.

      puts 'Icosa Class I Method 1 V6'

      radius = (1.0).m

      icosa_cim1v6 = IcosahedronCIM1V6.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V6', true)

      cmpnt_def = icosa_cim1v6.create_cim1v6_face_component(model)

      group = icosa_cim1v6.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cim1v6()

    def icosahedron_cim2v3()

      # Creates a Class I Method 2 V3 Icosahedron.

      puts 'Icosa Class I Method 2 V3'

      radius = (1.0).m

      icosa_cim2v3 = IcosahedronCIM2V3.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V3', true)

      cmpnt_def = icosa_cim2v3.create_cim2v3_face_component(model)

      group = icosa_cim2v3.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cim2v3()

    def icosahedron_cim2v4()

      # Creates a Class I Method 2 V4 Icosahedron.

      puts 'Icosa Class I Method 2 V4'

      radius = (1.0).m

      icosa_cim2v4 = IcosahedronCIM2V4.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V4', true)

      cmpnt_def = icosa_cim2v4.create_cim2v4_face_component(model)

      group = icosa_cim2v4.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cim2v4()

    def icosahedron_cim2v5()

      # Creates a Class I Method 2 V5 Icosahedron.

      puts 'Icosa Class I Method 2 V5'

      radius = (1.0).m

      icosa_cim2v5 = IcosahedronCIM2V5.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V5', true)

      cmpnt_def = icosa_cim2v5.create_cim2v5_face_component(model)

      group = icosa_cim2v5.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cim2v5()

    def icosahedron_cim2v6()

      # Creates a Class I Method 2 V6 Icosahedron.

      puts 'Icosa Class I Method 2 V6'

      radius = (1.0).m

      icosa_cim2v6 = IcosahedronCIM2V6.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V6', true)

      cmpnt_def = icosa_cim2v6.create_cim2v6_face_component(model)

      group = icosa_cim2v6.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cim2v6()

    def icosahedron_cikv3()

      # Creates a Class I Kruschke V3 Icosahedron.

      puts 'Icosa Class I Krushke V3'

      radius = (1.0).m

      icosa_cikv3 = IcosahedronCIKV3.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V3', true)

      cmpnt_def = icosa_cikv3.create_cikv3_face_component(model)

      group = icosa_cikv3.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cikv3()

    def icosahedron_cikv4()

      # Creates a Class I Kruschke V4 Icosahedron.

      puts 'Icosa Class I Krushke V4'

      radius = (1.0).m

      icosa_cikv4 = IcosahedronCIKV4.new(radius)

      model = Sketchup.active_model

#      model.close(true)

      Sketchup.file_new

      model.start_operation('Create Icosahedron V4', true)

      cmpnt_def = icosa_cikv4.create_cikv4_face_component(model)

      group = icosa_cikv4.add_face_components(model, cmpnt_def, true)

      model.commit_operation

#      group.explode

    end # icosahedron_cikv4()

  end # module Polyhedra

end # module BHL
