
# Programs must be written for people to read, and only incidentally for machines to execute.

# load 'yourpath\ExtPolyhedron\Polyhedron.rb'

# Copyright 2020 Bryan
# Licensed under the "my license"

require 'sketchup'

require_relative 'PolyLoader'
require_relative 'Icosahedron'

module BHL

  module Polyhedra

    extend self

    # To do: create an HTML dialog with selection options to reduce menu clutter

    def create_icosahedron_class_i_method_1()

      @freq_icosa_cim1 ||= 1

      prompts = ["Frequency"]

      values = [@freq_icosa_cim1]

      list = ["1|2|3|4|5|6", @freq_icosa_cim1]

      results = UI.inputbox(prompts, values, list, "Icosahedron Class I Method 1")

      return if not results

      @freq_icosa_cim1 = results[0]

      case @freq_icosa_cim1

        when 1 then icosahedron_civ1()
        when 2 then icosahedron_civ2()
        when 3 then icosahedron_cim1v3()
        when 4 then icosahedron_cim1v4()
        when 5 then icosahedron_cim1v5()
        when 6 then icosahedron_cim1v6()

      end

    end # create_icosahedron_class_i_method_1()

    def create_icosahedron_class_i_method_2()

      @freq_icosa_cim2 ||= 3

      prompts = ["Frequency"]

      values = [@freq_icosa_cim2]

      list = ["1|2|3|4|5|6", @freq_icosa_cim2]

      results = UI.inputbox(prompts, values, list, "Icosahedron Class I Method 2")

      return if not results

      @freq_icosa_cim2 = results[0]

      case @freq_icosa_cim2

        when 1 then icosahedron_civ1()
        when 2 then icosahedron_civ2()
        when 3 then icosahedron_cim2v3()
        when 4 then icosahedron_cim2v4()
        when 5 then icosahedron_cim2v5()
        when 6 then icosahedron_cim2v6()

      end

    end # create_icosahedron_class_i_method_2()

    def create_icosahedron_class_i_kruschke()

      @freq_icosa_cik ||= 3

      prompts = ["Frequency"]

      values = [@freq_icosa_cik]

      list = ["3|4|5|6", @freq_icosa_cik]

      results = UI.inputbox(prompts, values, list, "Icosahedron Class I Kruschke")

      return if not results

      @freq_icosa_cik = results[0]

      case @freq_icosa_cik

        when 3 then icosahedron_cikv3()
        when 4 then icosahedron_cikv4()
  #      when 5 then icosahedron_cikv5()
   #     when 6 then icosahedron_cikv6()

      end

    end # create_icosahedron_class_i_method_2()

    def create_icosahedron_cii()

      @freq_icosa_cii ||= 2

      prompts = ["Frequency"]

      values = [@freq_icosa_cii]

      list = ["2|4|6|8", @freq_icosa_cii]

      results = UI.inputbox(prompts, values, list, "Icosahedron Class II")

      return if not results

      @freq_icosa_cii = results[0]

#      case @freq_icosa_cii

 #       when 2 then icosahedron_ciiv2()
  #      when 4 then icosahedron_ciiv4()
   #     when 6 then icosahedron_ciiv6()
    #    when 8 then icosahedron_ciiv8()

     # end

    end # create_icosahedron_cii()

    def octahedron()

      UI.messagebox "Octa coming later"

    end # create_octahedron()

    def tetrahedron()

      UI.messagebox "Tetra coming later"

    end # create_tetrahedron()

    def hexahedron()

      UI.messagebox "Hexa coming later"

    end # create_hexahedron()

    def dodecahedron()

      UI.messagebox "Dodeca coming later"

    end # create_dodecahedron()

    def reload_polyhedron()

      SKETCHUP_CONSOLE.clear

      load 'yourpath\ExtPolyhedron\Polyhedron.rb'
      load 'yourpath\ExtPolyhedron\PolyLoader.rb'

      puts 'Polyhedron reloaded'

    end # reload_polyhedron()

    def reload_icosahedron()

      SKETCHUP_CONSOLE.clear

      load 'yourpath\ExtPolyhedron\Icosahedron.rb'

      puts 'Icosahedron reloaded'

    end # reload_icosahedron()

    unless file_loaded?(__FILE__)

      menu_Poly = UI.menu('Extensions').add_submenu('Polyhedra')

        menu_Icosa = menu_Poly.add_submenu('Icosahedron')

          menu_Icosa.add_item('Icosa Class I Method 1') {create_icosahedron_class_i_method_1}
          menu_Icosa.add_item('Icosa Class I Method 2') {create_icosahedron_class_i_method_2}
          menu_Icosa.add_item('Icosa Class I Kruschke') {create_icosahedron_class_i_kruschke}
          menu_Icosa.add_item('Icosa Class II') {create_icosahedron_cii}

          menu_Poly.add_item('Octahedron') {octahedron}
          menu_Poly.add_item('Tetrahedron') {tetrahedron}
          menu_Poly.add_item('Hexahedron') {hexahedron}
          menu_Poly.add_item('Dodecahedron') {dodecahedron}

      UI.menu('Extensions').add_separator

      menu_Test = UI.menu('Extensions')

        menu_Test.add_item('Icosa V1') {icosahedron_civ1()}
        menu_Test.add_item('Icosa V2') {icosahedron_civ2()}
        menu_Test.add_item('Reload Polyhedron') {reload_polyhedron}
        menu_Test.add_item('Reload Icosahedron') {reload_icosahedron}

      file_loaded(__FILE__)

    end # unless file_loaded?(__FILE__)

  end # module Polyhedra

end # module BHL

# load 'yourpath\ExtPolyhedron\Polyhedron.rb'
